﻿Imports System.IO
Imports System.Xml

Module Module1

    Dim x() As Single
    Dim y() As Single
    Dim n As Integer
    Dim A As Single
    Dim naslov As String
    Dim imeDat As String

    Sub Main(ByVal sArgs() As String)

        If sArgs.Length = 0 Then
            ' Interaktivni vnos podatkov s tipkovnico
            Podatki()
        Else
            Dim tmp As String = sArgs(0).ToLower()
            If tmp.EndsWith(".xml") Then
                imeDat = tmp.Substring(0, sArgs(0).Length - 4)
                PodatkiIzXmlDatoteke()
            ElseIf tmp.EndsWith(".txt") Then
                imeDat = tmp.Substring(0, sArgs(0).Length - 4)
                PodatkiIzDatoteke()
            Else
                Console.WriteLine("Napaka. Datoteke s podatki mora imeti končnico xml ali txt.")
                End
            End If
        End If
        ' 

        Izracun()
        Izpis()

    End Sub

    Sub PodatkiIzXmlDatoteke()
        Dim imeDatoteke As String = imeDat & ".xml"
        Dim xmlDoc As New XmlDocument
        xmlDoc.Load(imeDatoteke)

        Dim xmlPrerez As XmlElement = xmlDoc.DocumentElement()

        Dim xmlNaslov As XmlElement = xmlPrerez.SelectSingleNode("naslov")
        naslov = xmlNaslov.InnerText

        Dim xmlTocke As XmlElement = xmlPrerez.SelectSingleNode("tocke")
        Dim xmlTockeList As XmlNodeList = xmlTocke.SelectNodes("tocka")
        n = xmlTockeList.Count
        ReDim x(n + 1)
        ReDim y(n + 1)

        For Each xmlTocka As XmlNode In xmlTockeList
            Dim id As Integer = xmlTocka.Attributes.GetNamedItem("id").Value

            Dim xmlX As XmlElement = xmlTocka.SelectSingleNode("x")
            x(id) = xmlX.InnerText

            Dim xmlY As XmlElement = xmlTocka.SelectSingleNode("y")
            y(id) = xmlY.InnerText
        Next
        x(n + 1) = x(1)
        y(n + 1) = y(1)
    End Sub

    Sub IzpisVXml2()
        Dim imeDatoteke = imeDat & "2.xml"

        Console.WriteLine()
        Console.WriteLine("--- Izpis v XML datoteko (XML knjižnica) ...")

        Dim xmlDoc As New XmlDocument

        Dim xmlDec As XmlDeclaration = xmlDoc.CreateXmlDeclaration("1.0", "UTF-8", Nothing)
        xmlDoc.AppendChild(xmlDec)

        Dim xmlPrerez As XmlElement = xmlDoc.CreateElement("prerez")
        xmlDoc.AppendChild(xmlPrerez)

        Dim xmlNaslov As XmlElement = xmlDoc.CreateElement("naslov")
        xmlNaslov.InnerText = naslov
        xmlPrerez.AppendChild(xmlNaslov)

        Dim xmlTocke As XmlElement = xmlDoc.CreateElement("tocke")
        xmlPrerez.AppendChild(xmlTocke)

        For i As Integer = 1 To n
            Dim xmlTocka As XmlElement = xmlDoc.CreateElement("tocka")
            xmlTocka.SetAttribute("id", i)
            xmlTocke.AppendChild(xmlTocka)

            Dim xmlX As XmlElement = xmlDoc.CreateElement("x")
            xmlX.InnerText = x(i)
            xmlTocka.AppendChild(xmlX)

            Dim xmlY As XmlElement = xmlDoc.CreateElement("y")
            xmlY.InnerText = y(i)
            xmlTocka.AppendChild(xmlY)
        Next

        xmlDoc.Save(imeDatoteke)

        Console.WriteLine()
        Console.WriteLine("--- Izpis v XML datoteko zaključen.")

    End Sub

    Sub IzpisVXml()
        Dim imeDatoteke As String = imeDat & ".xml"

        Console.WriteLine()
        Console.WriteLine("--- Izpis v XML datoteko ...")

        Dim dat As StreamWriter
        dat = New StreamWriter(imeDatoteke)

        dat.WriteLine("<prerez>")
        dat.WriteLine("<naslov>" & naslov & "</naslov>")
        dat.WriteLine("<tocke>")
        For i As Integer = 1 To n
            dat.WriteLine("<tocka id=""{0}"">", i)
            dat.WriteLine("<x>{0}</x>", x(i))
            dat.WriteLine("<y>{0}</y>", y(i))
            dat.WriteLine("</tocka>")
        Next
        dat.WriteLine("</tocke>")
        dat.WriteLine("</prerez>")

        dat.Close()

        Console.WriteLine()
        Console.WriteLine("--- Izpis v XML datoteko zaključen.")

    End Sub

    Sub IzpisVTxt()
        Dim imeDatoteke As String = imeDat & ".txt"

        Dim dat As StreamWriter
        dat = New StreamWriter(imeDatoteke)

        dat.WriteLine(naslov)
        dat.WriteLine(n)
        For i As Integer = 1 To n
            dat.WriteLine("{0} {1}", x(i), y(i))
        Next

        dat.Close()

        Console.WriteLine()
        Console.WriteLine("--- Izpis v TXT datoteko zaključen.")
    End Sub

    Sub PodatkiIzDatoteke()
        Dim imeDatoteke As String = imeDat & ".txt"

        Dim dat As StreamReader
        dat = New StreamReader(imeDatoteke)

        naslov = dat.ReadLine()

        n = dat.ReadLine()
        ReDim x(n + 1)
        ReDim y(n + 1)

        For i As Integer = 1 To n
            Dim vrstica As String = dat.ReadLine()
            Dim besede() As String = vrstica.Split()

            x(i) = besede(0)
            y(i) = besede(1)
        Next
        x(n + 1) = x(1)
        y(n + 1) = y(1)

        dat.Close()
    End Sub

    Sub Podatki()
        Console.Write("Naslov primera: ")
        naslov = Console.ReadLine()

        Console.Write("Podaj število točk: ")
        n = Console.ReadLine()
        ReDim x(n + 1)
        ReDim y(n + 1)

        For i As Integer = 1 To n
            Console.Write("Točka {0} (x y): ", i)
            Dim vrstica As String = Console.ReadLine()
            Dim besede() As String = vrstica.Split()

            x(i) = besede(0)
            y(i) = besede(1)
        Next
        x(n + 1) = x(1)
        y(n + 1) = y(1)

        Console.WriteLine()
        Console.Write("Podaj ime izhodne datoteke: ")
        imeDat = Console.ReadLine()
        Console.WriteLine()
    End Sub

    Sub Izracun()
        A = 0
        For i As Integer = 1 To n
            A = A + (x(i + 1) + x(i)) * (y(i + 1) - y(i))
        Next
        A = 0.5 * A
    End Sub

    Sub Izpis()
        IzpisNaZaslon()
        IzpisVTxt()
        IzpisVXml()
        IzpisVXml2()
    End Sub

    Sub IzpisNaZaslon()
        Console.WriteLine("--- Podatki")
        Console.WriteLine("Naslov: " & naslov)
        Console.WriteLine("Št. točk = " & n)
        Console.WriteLine("Točke ...")
        For i As Integer = 1 To n
            Console.WriteLine("T({0}): x = {1}, y = {2}", i, x(i), y(i))
        Next
        Console.WriteLine()

        Console.WriteLine("--- Rezultati")
        Console.WriteLine("A = " & A)
    End Sub
End Module
